<template>
	<xn-form-container :title="'基本设置'" :width="800" :visible="visible" :destroy-on-close="true" @close="onClose">
		<a-form :model="formState" ref="formStateRef" :rules="formStateRules" name="basic" autocomplete="off">
			<div class="form">
				<a-row>
					<a-col :span="12">
						<a-form-item
							class="form-item"
							label="头条标题"
							name="headlineTitle"
							:label-col="{ span: 10 }"
							:rules="[{ required: true, message: '请输入头条标题!', trigger: 'change' }]"
						>
							<a-input
								placeholder="请输入头条标题"
								style="width: 600px"
								:disabled="disabled"
								v-model:value="formState.headlineTitle"
							/>
						</a-form-item>
					</a-col>
				</a-row>
				<a-row>
					<a-col :span="12">
						<a-form-item class="form-item" label="发布来源" name="publishSource" :label-col="{ span: 10 }">
							<a-input style="width: 250px" :disabled="disabled" v-model:value="formState.publishSource" />
						</a-form-item>
					</a-col>
					<a-col :span="12">
						<a-form-item class="form-item" label="发布时间" name="publishTime" :label-col="{ span: 10 }">
							<a-date-picker
								:disabled="disabled"
								v-model:value="formState.publishTime"
								valueFormat="YYYY-MM-DD HH:mm:ss"
								style="width: 250px"
							/>
						</a-form-item>
					</a-col>
				</a-row>

				<!--  -->
			</div>

			<div class="attachment"></div>
			<div><span style="color: red">* </span>头条内容:</div>
			<br />
			<a-form-item
				class="form-item"
				label="''"
				ref="EditorRef"
				name="carouselContent"
				:label-col="{ span: 0 }"
				:rules="[{ required: true, message: '请输入头条内容!', trigger: 'change' }]"
			>
				<Editor
					@getTXTLE="getTXTLEDEL"
					:fileUploadFunction="global.uploadFile"
					:placeholder="'请输入头条内容'"
					:disabled="disabled"
					v-model:modelValue="formState.carouselContent"
				/>
			</a-form-item>

			<a-form-item>
				<div class="item-submit">
					<a-button class="btn1" :disabled="disabled" @click="onFinish(2)">提交</a-button>
					<a-button class="btn1" :disabled="disabled" type="primary" @click="onFinish(1)">保存</a-button>
				</div>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
		</template>
	</xn-form-container>
</template>
<script lang="js">
	import business from '@/api/home/home.js'
	import { ref } from 'vue'
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import global from '@/api/home/global.js'
	export default {
		name: 'FromName',
		components: {},
		emits: ['change'],
		setup(props, { emit }) {
			const disabled = ref(false)
			const visible = ref(false)
			const records = ref('')
			const onOpen = (record, flag, view, row) => {
				records.value = record
				visible.value = flag
				disabled.value = view
				if (row) {
					detail(row.id)
				}
			}
			const detail = async (v) => {
				const res = await business.HOMEview({ id: v })
				formState.value = res
			}
			const rest = () => {
				for (let key in formState.value) {
					formState.value[key] = ''
				}
			}
			const onClose = () => {
				visible.value = false
				rest()
			}

			watch(
				() => visible.value,
				(newVal) => {
					if (!newVal) {
						setTimeout(() => {
							rest()
						}, 0)
					}
				},
				{ immediate: true, deep: true }
			)

			const formState = ref({
				headlineTitle: '',
				publishSource: '',
				publishTime: '',
				carouselContent: '',
				status: 0
			})
			const formStateRules = ref({
				// headlineTitle: [{ required: true, message: '请填写!', trigger: 'blur' }],
				// publishTime: [{ required: true, message: '请填写!', trigger: 'change' }],
				// attachment: [{ required: true, message: '请填写!', trigger: 'change' }]
			})
			const formStateRef = ref(null)

			const onFinish = async (status) => {
				formStateRef.value.validate().then(async () => {
					try {
						formState.value.status = status
						await handleAdd(formState.value)
						emit('change')
						onClose()
					} catch (err) {
						console.log(err)
					}
				})
			}

			const handleAdd = async (val) => {
				if (records.value == 'edit') {
					const res = await business.HOMEedit(val)
				} else {
					const res = await business.HOMEadd(val)
					console.log('add')
				}
			}

			const onFinishFailed = (errorInfo) => {
				console.log('Failed:', errorInfo)
			}
			// EditorRef
			const EditorRef = ref(null)
			const getTXTLEDEL = (v) => {
				if (v !== undefined || v !== null || v !== '') {
					EditorRef.value.clearValidate()
				}
			}
			return {
				getTXTLEDEL,
				EditorRef,
				global,
				formStateRef,
				formStateRules,
				formState,
				onFinish,
				onFinishFailed,
				disabled,
				onOpen,
				visible,
				onClose
			}
		}
	}
</script>
<style lang="less" scoped>
	.box1 {
		display: flex;
		justify-content: space-between;
		.box-left {
			width: 350px;
			align-items: center;
		}
		.box-right {
			width: 350px;
			margin-right: 10px;
			align-items: center;
		}
	}
	.common {
		display: flex;
		align-items: center;
		justify-content: center;
		margin-bottom: 30px;
		.title {
			width: 130px;
			text-align: right;
			margin-right: 5px;
		}
	}
	.input {
		margin-right: 10px;
		margin-left: 40px;
		margin-top: 20px;
		.ant-input-affix-wrapper {
			height: 100px;
		}
	}
	.btnBox {
		text-align: center;
		margin-top: 100px;
		.snowy-buttom-left {
			margin-left: 100px;
		}
		.acc {
			width: 80px;
			height: 40px;
		}
	}
	.form {
		display: flex;
		flex-wrap: wrap;
		// justify-content: center;
		.form-item {
			width: 250px;
			margin-right: 120px;
		}
	}
	.item-submit {
		display: flex;
		justify-content: center;
		margin-top: 100px;
		.btn1 {
			width: 100px;
			margin-right: 20px;
		}
	}
	.ant-select {
		width: 250px;
	}
	.ant-input {
		width: 250px;
	}
	.ant-form-item-label {
		width: 150px;
	}
	.attachment {
		margin-top: 30px;
		margin-left: 15px;
	}
</style>
